local A1, A2 = 727595, 798405  -- 5^17=D20*A1+A2
local D20, D40 = 1048576, 1099511627776  -- 2^20, 2^40
local X1, X2 = 0, 1
function rand()
    local U = X2*A2
    local V = (X1*A2 + X2*A1) % D20
    V = (V*D20 + U) % D40
    X1 = math.floor(V/D20)
    X2 = V - X1*D20
    return V/D40
end


function main(self)
	if self.State == 0 then
		self.State = 1
        
		self.isStunnedFlag = 0
		
	end
	if GetClaw().Height > 0 and self.isStunnedFlag == 0 then
		
		if GetClaw().Health > 0 then
			GetClaw().State = 31
			self.isStunnedFlag = 1
			--TextOut(GetClaw().Height)
			local claw = GetClaw()
			if rand()<0.5 then
				claw:SetAnimation("CLAW_DAMAGE1")
			else
				claw:SetAnimation("CLAW_DAMAGE2")
			end
			local r = rand()
			if r<0.25 then
				PlaySound("CLAW_1110048")
			elseif r<0.5 then
				PlaySound("CLAW_1110049")
			elseif r<0.75 then
				PlaySound("CLAW_1110050")
			else
				PlaySound("CLAW_1110051")
			end
		else
			self.isStunnedFlag = 0
		end
	end
	if GetClaw().Height == 0 and self.isStunnedFlag == 1 then
		if GetClaw().Health > 0 then
			--GetClaw().State = 24
			GetClaw().State = 9
			local input = GetInput()
			local claw = GetClaw()
			
			ClawJump(0)
			--[[if AND(input,0x1000000)~=0 then
				GetClaw().State = 9
				claw:SetAnimation("CLAW_WALK")
				
			end
			if AND(input,0x2000000)~=0 then
				GetClaw().State = 8
				claw:SetAnimation("CLAW_WALK")
			end--]]
		end
		self.isStunnedFlag = 0
	end
	if GetClaw().Height > 0 then
		GetClaw().Height = GetClaw().Height - 1
	end
end